#ifndef _xtime_h

#ifndef lint
static const char rcsid[] = "$Header: /net/hopkins/home/tristan/mpeg/dec/lib/RCS/xtime.c,v 1.4 1999/07/06 10:14:41 tristan Exp $";
static const char copyright[] = "Copyright (c) 1997, MpegTV LLC";
#endif

#endif /* not _xtime_h */

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

/*--------------------------------------------------------------------------+
| Configuration flags
+--------------------------------------------------------------------------*/

#ifdef WIN32
#define USE_TICKS
#endif

/*--------------------------------------------------------------------------+
| Macros																	|
+--------------------------------------------------------------------------*/

#ifndef XTIME_INLINE

#ifdef _xtime_c
	damned! _xtime_c should not be defined here!!!
#else
#	define _xtime_c
#endif

#include "xtime.h"

#ifdef _XTIME_INLINE
	damned! _XTIME_INLINE should not be defined here!!!
#else
#	define _XTIME_INLINE
#endif

#else /* XTIME_INLINE */


/*
 * When xtime.c is compiled as included in-line
 * by xtime.h, then _XTIME_INLINE should be already defined.
 */
 
#ifndef _XTIME_INLINE
	damned! _XTIME_INLINE should be defined here!!!
#endif

#endif /* XTIME_INLINE */

#ifdef WIN32
#ifndef USE_TICKS
/*----------------------------------------------------------------------
|       constants
+---------------------------------------------------------------------*/
#define EPOCH_OFFSET  116444736000000000i64

/*----------------------------------------------------------------------
|       types
+---------------------------------------------------------------------*/
typedef union {
    unsigned __int64 int64_time;
    FILETIME         file_time;
} WINDOWSTIME;

#endif
#endif

/*--------------------------------------------------------------------------+
| xtime_get_time_now
+--------------------------------------------------------------------------*/
_XTIME_INLINE double
xtime_get_time_now()
{
	double time_now;
#ifdef WIN32
//	struct _timeb now;

//	_ftime(&now);

//	time_now = now.time + now.millitm * (1.0/1000);

#ifdef USE_TICKS

//	DWORD now = GetTickCount();
	/* tick count is in millseconds and wraps arount in 49 days */
//	return now * (1.0/1000);
	u_int	tick_count;

	tick_count = GetTickCount();
	time_now = (double)tick_count * 0.001;

#else /* not USE_TICKS */

    SYSTEMTIME  system_time;
    WINDOWSTIME windows_time;

    GetSystemTime(&system_time);
    if (SystemTimeToFileTime(&system_time, &windows_time.file_time)) {
        return (double)(__int64)(windows_time.int64_time - EPOCH_OFFSET) * 0.000000100;
    } else {
        return 0.0;
    }
#endif  /* not USE_TICKS */
   
#else
	struct timeval now;

	gettimeofday(&now, NULL);

#if 0 /* Tristan Savatier - Tue Nov 19 02:25:09 PST 1996 */
//	printf("now.tv_sec = %d\n", now.tv_sec);
//	printf("now.tv_usec = %d\n", now.tv_usec);
#endif /* 0 - Tristan Savatier - Tue Nov 19 02:25:09 PST 1996 */
	
	time_now = now.tv_sec + now.tv_usec * (1.0/MILLION);
#endif
	return time_now;
}

/*--------------------------------------------------------------------------+
| xtime_sleep
+--------------------------------------------------------------------------*/
_XTIME_INLINE void
xtime_sleep(double seconds)
{
#ifdef WIN32
	DWORD	n = (DWORD)(seconds * 1000);
	
	if (n > 0) {
		Sleep(n);
	}
#else
	usleep((u_long)(seconds * MILLION));
#endif
}


/* eof */
